/*


dnsgrep v0.16 beta


TODO:
		- code cleanup
		- make a smart hostname generator ( * it's will be point on this code )
		- real stealth function.
		- reverse dns lookup

http://packetstormsecurity.org/UNIX/scanners/dnsenum.zip 
above script also good thanks, and maybe dnsgrep-1.0 would be more useful and curious.


- gein


Example:

	./dnsgrep -d friend.com -m dictionary -D most.lst -sQ -o [domain.c]

	or

	./dnsgrep -d friend.com -m download_zone

*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <getopt.h>


#define	PROGRAM		"dnsgrep v0.16 beta by geinblues ( geinblues@gmail.com )"
#define HOST		"/usr/bin/host"

int is_weakness(char *Query_domain);
int download_zone(char *Query_domain);


int main(int argc, char **argv)
{
	FILE *fdd, *fdl;
	struct hostent *host;
	struct in_addr sock_addr;
	char temp[20], dom[50], temp_str[100], hostlist_file[20], fout[20];
	int cnt_try = 1, cnt_words = 0, per = 0, tfdd=0, delay = 0, opt = 0, scan_mode = -1;
	static char optstr[] = "d:m:s:D:o:";
	char usage[] = {
	
		"\n%s usage : %s -d *target domain -m *<dictionary/download_zone>\n"
		"\tdictionary mode:\n"
		"\t\t-D <word file>\n"
		"\t\t-sS : stealth mode\n"
		"\t\t-sN : normal mode\n"
		"\t\t-sQ : quick mode\n"
		"\n\t-o <output filename>\n"

	};

	if(argc < 2) {

        printf(usage, PROGRAM, argv[0]);
        exit(-1);
	
	}

	strcpy(fout, "log.txt");

	/* strncpy(dom, argv[1], sizeof(dom)); */

	while((opt = getopt(argc, argv, optstr)) != -1) {
		
		switch(opt) {

			case 'd':
				
				strcpy(dom, optarg);
				break;

			case 'm':
				
				if(!strcmp(optarg, "dictionary")) {
					scan_mode = 0;
				} else if(!strcmp(optarg, "download_zone")) {
					scan_mode = 1;
				}
				break;

			case 'D':
				
				if(scan_mode == 0 || scan_mode != 1) {
					strcpy(hostlist_file, optarg); 
				}
				break;
			
			/* added since 0.14b */
			case 'o':
				
				if(scan_mode == 0 || scan_mode != 1) {
					strcpy(fout, optarg);
				}
				break;

			case 's':
		
				switch(optarg[0]) {
			
					case 'S':	// stealth mode
						delay = 300;
						break;
					
					case 'N':	// normal mode
						delay = 3;
						break;
					
					case 'Q':	// quick mode
						delay = 0;	
						break;

					default:
						delay = 0;

				}

		}

	}

	/* if domain arg is not suplied. */
	if(strlen(dom) <= 2) {

		printf("You have to supply -d option with domain\n");
		exit(-1);
	
	}

	if(scan_mode == 1) {
	
		download_zone(dom);
	
	} else if(scan_mode == 0 || scan_mode != 1) {


		/* counting number of the words in hostlist files */
		
		if((fdd = fopen(hostlist_file, "r")) == NULL) {
		
			 printf("%s dictionary file is not found\n", hostlist_file);
			 exit(-2);
		
		}

		/* check out is suplied dns server is vulnerable by dnsgrep's juggling */

		if(is_weakness(dom) == -1) {
		
				printf("\nit's not vulnerable for dnsgrep\n\n");
				exit(-1);

		}

		while(!feof(fdd)) {

			fscanf(fdd, "%s\n", &temp);
			cnt_words++;
		
		}

		memset(temp, 0, sizeof(temp));

		printf("\n\n+ -- --=[ %s [%s = %d hostnames]\n", PROGRAM, hostlist_file, cnt_words);
		printf("dnsgrep> SET MODE = dictionary\n\n");

		rewind(fdd);

		memset(temp_str, 0, sizeof(temp_str));
		sprintf(temp_str, "rm -rf %s; touch %s", fout, fout);
		system(temp_str);

		memset(temp, 0, sizeof(temp));
		memset(temp_str, 0, sizeof(temp_str));

		while(!feof(fdd)) {

			fscanf(fdd, "%s", &temp);
			sprintf(temp_str, "%s.%s", temp, dom);

			host = NULL;
	
			/* query dns by hostname.domain */
		    	host = gethostbyname(temp_str);
        
			if(host) {

				fdl = fopen(fout, "a+");
				/* added ip address output since 0.14b */
				sock_addr.s_addr = *((unsigned long *)(host->h_addr_list[0]));
				sprintf(temp_str, "%s\t( %s )\t<< found!!", temp_str, inet_ntoa(sock_addr));
				fprintf(fdl, "%s\n",  temp_str);
				fclose(fdl);
			
			} else
				sprintf(temp_str, "%s", temp_str);

			printf("%d tries of %d : %s\n", cnt_try++, cnt_words, temp_str);

			sleep(delay);

			if(feof(fdd)) break;	// for fix last once overhead since 0.14b
	
		}

		fclose(fdd);
	}

return 0;

}


int is_weakness(char *Query_domain)
{
	struct hostent *khost;
	char oops_host[] = "wOoOoOoOow.";
	char *query;
	int siz;

	siz = strlen(Query_domain) + strlen(oops_host);

	query = (char *) malloc(siz);

	memcpy(query, oops_host, strlen(oops_host) + 1);

	query = strcat(query, Query_domain);	

	printf("\n[+] check out DNS : %s\n", query);

	khost = gethostbyname(query);

	free(query);

	if(khost)
		return -1;

return 0;
		
}


/* it's dumb zone transfer scanning module by using host tool since Ver 0.11b */

int download_zone(char *Query_domain)
{
char query_cmd[100];
char ns[80];

	printf("dnsgrep::download_zone> SET DOMAIN %s\n\n", Query_domain);

	sprintf(query_cmd, "host -t ns %s", Query_domain); 	
	system(query_cmd);

 	printf("\nns : ");	
	scanf("%s", &ns);
	
	printf("\ndnsgrep::download_zone> SET ns %s\n", ns);

	printf("Downloading Zone Records..\n");
	sleep(2);

	sprintf(query_cmd, "host -l %s %s | less\n", Query_domain, ns);
	system(query_cmd);	

exit(0);

}
